-- =============================================
-- Author			: FID.Ridwan
-- Created date		: 2019-02-13
-- Description		: Using for generate kanban
-- Modified by		: FID.Dina
-- Modified date	: 26-Jun-2019
-- Modified desc	: Change criteria date from Order Release Date to Created Date, refer to order release logic
-- =============================================
CREATE PROCEDURE [dbo].[SP_GenerateKanban2_FID] @Username VARCHAR(50) = 'TVEST.Admin' -- Emergency Order
	,@SessionID VARCHAR(50) = 'mtwbaxer1yuwadclqy03fys5' -- Emergency Order
	,@MANIFEST_NO VARCHAR(16) = 'E119000009' -- Emergency Order
	,@ITEM_NO INT = 2 -- Emergency Order
	,@SUPPLIER_CD VARCHAR(6) = '0007' -- Emergency Order
	,@SUPPLIER_PLANT CHAR(1) = '2' -- Emergency Order
	,@DOCK_CD VARCHAR(2) = '1N' -- Emergency Order
	,@ProcessId INT = 0 -- Normal Order (Temp)
	,@TYPE INT = 2 -- 1 = Emergency Order , 2 = Normal Order
	,@OrderReleaseDate VARCHAR(MAX) = '27.09.2019' -- Normal Order
	,@RcvPlantCode VARCHAR(MAX) = '1'
AS
BEGIN
	DECLARE @T AS TABLE (PID BIGINT)
	DECLARE @pid AS BIGINT = 0
	DECLARE @log AS VARCHAR(MAX)
	DECLARE @MODULE_ID AS VARCHAR(1) = '2'
	DECLARE @FUNCTION_ID AS VARCHAR(MAX) = 'AG100312'
	DECLARE @R_SEQ_NO INT
	DECLARE @DOCK_PACKING VARCHAR(MAX);
	DECLARE @RCV_PLANT VARCHAR(MAX);
	DECLARE @COMPANY_CODE VARCHAR(MAX);
	DECLARE @TB_T_LOG_D AS TABLE (
		PROCESS_ID BIGINT
		,SEQUENCE_NUMBER INT
		,MESSAGE_ID VARCHAR(12)
		,MESSAGE_TYPE VARCHAR(3)
		,[MESSAGE] VARCHAR(MAX)
		,LOCATION VARCHAR(MAX)
		,CREATED_BY VARCHAR(20)
		,CREATED_DATE DATETIME
		)

	IF @TYPE = 1
	BEGIN
		SELECT @MANIFEST_NO AS MANIFEST_NO
			,@ITEM_NO ITEM_NO
			,@ITEM_NO + 1 NEW_ITEM_NO
			,SUPPLIER_CD
			,SUPPLIER_PLANT
			,D.RCV_PLANT_CD
			,T.DOCK_CD
			,PART_NO
			,KANBAN_PRINT_ADDRESS
			,KANBAN_NO
			,QTY_PER_CONTAINER
			,ORDER_QTY
			,PIECES_QTY
			,PART_NAME
			,IMPORTIR_INFO
			,IMPORTIR_INFO2
			,IMPORTIR_INFO3
			,IMPORTIR_INFO4
		INTO #T1
		FROM TB_T_EMERGENCY_ORDER_PART T
		JOIN (
			SELECT DISTINCT d.PLANT_CD AS RCV_PLANT_CD
				,D.DOCK_CD
			FROM TB_M_DOCK d
			INNER JOIN TB_M_PLANT p ON d.PLANT_CD = p.PLANT_CD
			) D ON T.DOCK_CD = D.DOCK_CD
		WHERE ORDER_QTY > 0
			AND ISNULL(PART_BARCODE, '') = ''
			AND T.UserID = @Username
			AND T.SessionID = @SessionID
			AND T.SUPPLIER_CD = @SUPPLIER_CD
			AND T.SUPPLIER_PLANT = @SUPPLIER_PLANT
			AND T.DOCK_CD = @DOCK_CD

		DECLARE @RN INT = 2
			,@T_COUNT INT = 0
			,@SEQ INT = 1

		SELECT *
		INTO #T2
		FROM #T1

		SELECT @T_COUNT = COUNT(1)
		FROM #T1
		WHERE ORDER_QTY >= @RN

		WHILE @T_COUNT > 0
		BEGIN
			INSERT INTO #T2
			SELECT MANIFEST_NO
				,ITEM_NO
				,ITEM_NO + @SEQ NEW_ITEM_NO
				,SUPPLIER_CD
				,SUPPLIER_PLANT
				,RCV_PLANT_CD
				,DOCK_CD
				,PART_NO
				,KANBAN_PRINT_ADDRESS
				,KANBAN_NO
				,QTY_PER_CONTAINER
				,ORDER_QTY
				,PIECES_QTY
				,PART_NAME
				,IMPORTIR_INFO
				,IMPORTIR_INFO2
				,IMPORTIR_INFO3
				,IMPORTIR_INFO4
			FROM #T1
			WHERE ORDER_QTY >= @RN

			SET @RN = @RN + 1
			SET @SEQ = @SEQ + 1

			SELECT @T_COUNT = COUNT(1)
			FROM #T1
			WHERE ORDER_QTY >= @RN
		END

		SELECT MANIFEST_NO
			,ITEM_NO + ROW_NUMBER() OVER (
				PARTITION BY ITEM_NO ORDER BY MANIFEST_NO
					,PART_NO
				)
			--,ROW_NUMBER() OVER (
			--	PARTITION BY ITEM_NO ORDER BY MANIFEST_NO
			--		,PART_NO
			--	) SEQ_KANBAN_ITEM
			,MANIFEST_NO + RIGHT('00' + CAST(NEW_ITEM_NO AS VARCHAR(10)), 3) + RIGHT('00' + CAST(ROW_NUMBER() OVER (
						PARTITION BY ITEM_NO ORDER BY MANIFEST_NO
							,PART_NO
						) AS VARCHAR(10)), 3) PART_BARCODE
			,SUPPLIER_CD
			,SUPPLIER_PLANT
			--,RCV_PLANT_CD
			,DOCK_CD
			,PART_NO
			,KANBAN_PRINT_ADDRESS
			,KANBAN_NO
			,QTY_PER_CONTAINER
			,ORDER_QTY
			,PIECES_QTY
			,PART_NAME
			,IMPORTIR_INFO
			,IMPORTIR_INFO2
			,IMPORTIR_INFO3
			,IMPORTIR_INFO4
			,@SessionID AS SessionID
			,@Username AS UserID
		FROM #T2

		DROP TABLE #T1

		DROP TABLE #T2
	END
	ELSE
		IF @TYPE = 2
		BEGIN
			SET @log = 'Create Kanban 2 Batch is started' --'Starting [Create Kanban 2]';

			INSERT @T
			EXEC dbo.sp_PutLog @log
				,@Username
				,'Start log'
				,@pid OUTPUT
				,'MCEDSTD006I'
				,'INF'
				,@MODULE_ID
				,@FUNCTION_ID;

			SET @log = 'Executing get configuration setting process';

			INSERT INTO @TB_T_LOG_D
			SELECT @pid
				,NULL
				,'MCEDSTD021I'
				,'INF'
				,@log
				,'Get configuration setting'
				,@Username
				,GETDATE()

			SELECT @DOCK_PACKING = TSYS.SYSTEM_VALUE
			FROM dbo.TB_M_SYSTEM TSYS
			WHERE TSYS.FUNCTION_ID = 'DOCK_PACKING'
				AND TSYS.SYSTEM_CD = 'NORMAL_ORDER'

			SELECT @RCV_PLANT = TSYS.SYSTEM_VALUE
			FROM dbo.TB_M_SYSTEM TSYS
			WHERE TSYS.FUNCTION_ID = 'RCV_PLANT'
				AND TSYS.SYSTEM_CD = 'NORMAL_ORDER'

			SELECT @COMPANY_CODE = TSYS.SYSTEM_VALUE
			FROM dbo.TB_M_SYSTEM TSYS
			WHERE TSYS.FUNCTION_ID = 'COMPANY_CODE'
				AND TSYS.SYSTEM_CD = 'NORMAL_ORDER'

			SET @log = 'Executing get daily order part data for Kanban 2 process';

			INSERT INTO @TB_T_LOG_D
			SELECT @pid
				,NULL
				,'MCEDSTD021I'
				,'INF'
				,@log
				,'Get daily order part data for Kanban 2'
				,@Username
				,GETDATE()

			DELETE
			FROM TB_S_DAILY_ORDER_PART

			DELETE
			FROM TB_S_DAILY_ORDER_PART_KANBAN2

			DELETE
			FROM TB_S_DAILY_ORDER_PART_KANBAN2_FILTER

			INSERT INTO TB_S_DAILY_ORDER_PART (
				[MANIFEST_NO]
				,[ITEM_NO]
				,[SUPPLIER_PLANT]
				,[RCV_PLANT_CD]
				,[DOCK_CD]
				,[PART_NO]
				,[KANBAN_PRINT_ADDRESS]
				,[KANBAN_NO]
				,[QTY_PER_CONTAINER]
				,[ORDER_QTY]
				,[ORDER_PLAN_QTY_LOT]
				,[RECEIVED_STATUS]
				,[BUILD_OUT_FLAG]
				,[BUILD_OUT_QTY]
				,[AICO_CEPT_FLAG]
				,[SUPPLIER_NAME]
				,[PART_NAME]
				,[ORDER_MODE]
				,[KANBAN_PRINT_POINT_CD]
				,[KANBAN_PRINT_DATE_PLANT]
				,[KANBAN_PRINT_DATE_LOCAL]
				,[CONVEYANCE_ROUTE]
				,[FERRY_PORT_ARRIVAL_DT]
				,[FERRY_PORT_DEPART_DT]
				,[EKBS_FLAG]
				,[EKBS_DT]
				,[PACKAGE_TYPE]
				,[RECEIVE_PLANT_NAME]
				,[SUPPLIER_INFO1]
				,[SUPPLIER_INFO2]
				,[SUPPLIER_INFO3]
				,[PRINT_CD]
				,[IMPORTIR_INFO]
				,[IMPORTIR_INFO2]
				,[IMPORTIR_INFO3]
				,[IMPORTIR_INFO4]
				,[CREATED_BY]
				,[CREATED_DT]
				,[CHANGED_BY]
				,[CHANGED_DT]
				,[PART_BARCODE]
				,[POSTING_STS]
				,[CASE_NO]
				,[MOD_DST_CD]
				,[BOX_NO]
				,[PLN_PCK_DT]
				,[CONT_SNO]
				,[PROCESS_TYPE]
				,[LOT_MOD_NO]
				,AGENT_PROCESSED_DT
				,CANCEL_FLAG
				,CANCEL_BY
				,CANCEL_DT
				,REMARK
				)
			SELECT P.[MANIFEST_NO]
				,P.[ITEM_NO]
				,P.[SUPPLIER_PLANT]
				,P.[RCV_PLANT_CD]
				,P.[DOCK_CD]
				,P.[PART_NO]
				,P.[KANBAN_PRINT_ADDRESS]
				,P.[KANBAN_NO]
				,P.[QTY_PER_CONTAINER]
				,P.[ORDER_QTY]
				,P.[ORDER_PLAN_QTY_LOT]
				,P.[RECEIVED_STATUS]
				,P.[BUILD_OUT_FLAG]
				,P.[BUILD_OUT_QTY]
				,P.[AICO_CEPT_FLAG]
				,P.[SUPPLIER_NAME]
				,P.[PART_NAME]
				,P.[ORDER_MODE]
				,P.[KANBAN_PRINT_POINT_CD]
				,P.[KANBAN_PRINT_DATE_PLANT]
				,P.[KANBAN_PRINT_DATE_LOCAL]
				,P.[CONVEYANCE_ROUTE]
				,P.[FERRY_PORT_ARRIVAL_DT]
				,P.[FERRY_PORT_DEPART_DT]
				,P.[EKBS_FLAG]
				,P.[EKBS_DT]
				,P.[PACKAGE_TYPE]
				,P.[RECEIVE_PLANT_NAME]
				,P.[SUPPLIER_INFO1]
				,P.[SUPPLIER_INFO2]
				,P.[SUPPLIER_INFO3]
				,P.[PRINT_CD]
				,P.[IMPORTIR_INFO]
				,P.[IMPORTIR_INFO2]
				,P.[IMPORTIR_INFO3]
				,P.[IMPORTIR_INFO4]
				,P.[CREATED_BY]
				,P.[CREATED_DT]
				,P.[CHANGED_BY]
				,P.[CHANGED_DT]
				,P.[PART_BARCODE]
				,P.[POSTING_STS]
				,P.[CASE_NO]
				,P.[MOD_DST_CD]
				,P.[BOX_NO]
				,P.[PLN_PCK_DT]
				,P.[CONT_SNO]
				,P.[PROCESS_TYPE]
				,P.[LOT_MOD_NO]
				,GETDATE()
				,M.CANCEL_FLAG
				,M.CANCEL_BY
				,M.CANCEL_DT
				,''
			FROM TB_R_DAILY_ORDER_MANIFEST M
			JOIN TB_R_DAILY_ORDER_PART P ON M.MANIFEST_NO = P.MANIFEST_NO
			WHERE 1 = 1
				--AND P.ORDER_QTY > 0
				--AND ISNULL(P.PART_BARCODE, '') = ''
				AND (
					ISNULL(M.MANIFEST_RECEIVE_FLAG, '0') = '0'
					AND M.ARRIVAL_ACTUAL_DT IS NULL
					) --FID) Dina 11-Jun-2019 : Additional condition for ARRIVAL_ACTUAL_DT IS NULL
				----AND CONVERT(VARCHAR, M.ORDER_RELEASE_DT, 104) = @OrderReleaseDate --FID) Dina 26-Jun-2019 : Commented
				AND CONVERT(VARCHAR, M.ORDER_RELEASE_DT, 104) between @OrderReleaseDate and '22.10.2019' --FID) Dina 26-Jun-2019 : Commented
				--AND CONVERT(VARCHAR, M.CREATED_DT, 104) = @OrderReleaseDate --FID) Dina 26-Jun-2019 : Remove filter by date
				--AND M.RCV_PLANT_CD IN ( --FID) Dina 26-Jun-2019 : Commented
				--	SELECT LTRIM(RTRIM(items))
				--	FROM dbo.FN_SPLIT(@RCV_PLANT, ',')
				--	)
				AND M.RCV_PLANT_CD = @RcvPlantCode --FID) Dina 26-Jun-2019 : Modify parameter for Receive Plant Code
				AND M.DOCK_CD IN (
					SELECT LTRIM(RTRIM(items))
					FROM dbo.FN_SPLIT(@DOCK_PACKING, ',')
					)
				AND M.COMPANY_CD IN (
					SELECT LTRIM(RTRIM(items))
					FROM dbo.FN_SPLIT(@COMPANY_CODE, ',')
					)
				----FID.Ridwan 2019-10-18 : temporary
				--AND LEFT(M.ORDER_NO, 8) >= '20191028'

			IF (
					SELECT COUNT(1)
					FROM TB_S_DAILY_ORDER_PART
					WHERE 1 = 1
						AND ORDER_QTY > 0
						AND ISNULL(PART_BARCODE, '') = ''
					) = 0
			BEGIN
				--SET @log = 'Daily Order Part data for Kanban 2 with Order Release Date ' + @OrderReleaseDate + ' not found on Daily Order Manifest table'; --FID) Dina 26-Jun-2019 : Commented
				--SET @log = 'Daily Order Part data for Kanban 2 with Created Date ' + @OrderReleaseDate + ' not found on Daily Order Manifest table'; --FID) Dina 26-Jun-2019 : Modify change criteria date
				SET @log = 'Daily Order Part data for Kanban 2 with Receive Plant Code ' + @RcvPlantCode + ' not found on Daily Order Manifest table';--FID) Dina 27-Jun-2019

				INSERT INTO @TB_T_LOG_D
				SELECT @pid
					,NULL
					,'MCED0312001E'
					,'ERR'
					,@log
					,'Daily order part data for Kanban 2 not found'
					,@Username
					,GETDATE()

				SET @log = 'Create Kanban 2 Batch is ended with error.';

				INSERT INTO @TB_T_LOG_D
				SELECT @pid
					,NULL
					,'MCEDSTD009I'
					,'INF'
					,@log
					,'End log with error'
					,@Username
					,GETDATE()

				SELECT TOP 1 @R_SEQ_NO = SEQUENCE_NUMBER
				FROM TB_R_LOG_D
				WHERE PROCESS_ID = @pid
				ORDER BY SEQUENCE_NUMBER DESC

				INSERT INTO TB_R_LOG_D (
					PROCESS_ID
					,SEQUENCE_NUMBER
					,MESSAGE_ID
					,MESSAGE_TYPE
					,[MESSAGE]
					,LOCATION
					,CREATED_BY
					,CREATED_DATE
					)
				SELECT PROCESS_ID
					,@R_SEQ_NO + ROW_NUMBER() OVER (
						ORDER BY PROCESS_ID
						)
					,MESSAGE_ID
					,MESSAGE_TYPE
					,[MESSAGE]
					,LOCATION
					,CREATED_BY
					,CREATED_DATE
				FROM @TB_T_LOG_D

				UPDATE TB_R_LOG_H
				SET PROCESS_STATUS = 6
				WHERE PROCESS_ID = @pid
			END
					/*ELSE IF EXISTS(SELECT TOP 1 1 FROM TB_S_DAILY_ORDER_PART WHERE ISNULL(ORDER_PLAN_QTY_LOT,0) = 0
																			AND ISNULL(ORDER_QTY,0) > 0) --FID) Dina 08-May-2019 : Additional condition
			BEGIN
				SET @log = 'Create Kanban 2 has been aborted due to Order Plan Qty Lot = 0 for Manifest No {0}';

				INSERT INTO @TB_T_LOG_D
				SELECT @pid
					,NULL
					,'MCED0312001E'
					,'ERR'
					,REPLACE(@log,'{0}',ISNULL(A.MANIFEST_NO,''))
					,'Create Kanban 2'
					,@Username
					,GETDATE()
				FROM (SELECT DISTINCT MANIFEST_NO FROM TB_S_DAILY_ORDER_PART WHERE ISNULL(ORDER_PLAN_QTY_LOT,0) = 0) A

				SET @log = 'Create Kanban 2 Batch is ended with error.';

				INSERT INTO @TB_T_LOG_D
				SELECT @pid
					,NULL
					,'MCEDSTD009I'
					,'INF'
					,@log
					,'End log with error'
					,@Username
					,GETDATE()

				SELECT TOP 1 @R_SEQ_NO = SEQUENCE_NUMBER
				FROM TB_R_LOG_D
				WHERE PROCESS_ID = @pid
				ORDER BY SEQUENCE_NUMBER DESC

				INSERT INTO TB_R_LOG_D (
					PROCESS_ID
					,SEQUENCE_NUMBER
					,MESSAGE_ID
					,MESSAGE_TYPE
					,[MESSAGE]
					,LOCATION
					,CREATED_BY
					,CREATED_DATE
					)
				SELECT PROCESS_ID
					,@R_SEQ_NO + ROW_NUMBER() OVER (
						ORDER BY PROCESS_ID
						)
					,MESSAGE_ID
					,MESSAGE_TYPE
					,[MESSAGE]
					,LOCATION
					,CREATED_BY
					,CREATED_DATE
				FROM @TB_T_LOG_D

				UPDATE TB_R_LOG_H
				SET PROCESS_STATUS = 6
				WHERE PROCESS_ID = @pid
			END*/
			ELSE
			BEGIN
				SET @log = 'Split and insert order data as much as order qty divided by order plan qty lot';

				INSERT INTO @TB_T_LOG_D
				SELECT @pid
					,NULL
					,'MCEDSTD021I'
					,'INF'
					,@log
					,'Split and insert order data'
					,@Username
					,GETDATE()

				DECLARE @RN2 INT = 1
					,@T_COUNT2 INT = 0

				--SELECT *
				--INTO #Temp2
				--FROM #Temp1
				SELECT @T_COUNT2 = COUNT(1)
				FROM TB_S_DAILY_ORDER_PART
				WHERE ORDER_QTY >= @RN2
					AND ISNULL(ORDER_QTY, 0) > 0
					AND ISNULL(PART_BARCODE, '') = ''
					AND ISNULL(ORDER_PLAN_QTY_LOT, 0) > 0

				WHILE @T_COUNT2 > 0
				BEGIN
					INSERT INTO TB_S_DAILY_ORDER_PART_KANBAN2 (
						MANIFEST_NO
						,ITEM_NO
						,SUPPLIER_PLANT
						,RCV_PLANT_CD
						,DOCK_CD
						,PART_NO
						,KANBAN_PRINT_ADDRESS
						,KANBAN_NO
						,QTY_PER_CONTAINER
						,ORDER_QTY
						,ORDER_PLAN_QTY_LOT
						,RECEIVED_STATUS
						,PART_BARCODE
						,BUILD_OUT_FLAG
						,BUILD_OUT_QTY
						,AICO_CEPT_FLAG
						,SUPPLIER_NAME
						,PART_NAME
						,ORDER_MODE
						,KANBAN_PRINT_POINT_CD
						,KANBAN_PRINT_DATE_PLANT
						,KANBAN_PRINT_DATE_LOCAL
						,CONVEYANCE_ROUTE
						,FERRY_PORT_ARRIVAL_DT
						,FERRY_PORT_DEPART_DT
						,EKBS_FLAG
						,EKBS_DT
						,PACKAGE_TYPE
						,RECEIVE_PLANT_NAME
						,SUPPLIER_INFO1
						,SUPPLIER_INFO2
						,SUPPLIER_INFO3
						,PRINT_CD
						,IMPORTIR_INFO
						,IMPORTIR_INFO2
						,IMPORTIR_INFO3
						,IMPORTIR_INFO4
						,CREATED_BY
						,CREATED_DT
						,CHANGED_BY
						,CHANGED_DT
						,POSTING_STS
						,CASE_NO
						,MOD_DST_CD
						,BOX_NO
						,PLN_PCK_DT
						,CONT_SNO
						,PROCESS_TYPE
						,LOT_MOD_NO
						,CANCEL_FLAG
						,CANCEL_BY
						,CANCEL_DT
						,REMARK
						,AGENT_PROCESSED_DT
						)
					SELECT MANIFEST_NO
						,ITEM_NO
						,SUPPLIER_PLANT
						,RCV_PLANT_CD
						,DOCK_CD
						,PART_NO
						,KANBAN_PRINT_ADDRESS
						,KANBAN_NO
						,QTY_PER_CONTAINER
						,(ORDER_QTY / ORDER_PLAN_QTY_LOT) ORDER_QTY
						,'1' ORDER_PLAN_QTY_LOT
						,RECEIVED_STATUS
						,PART_BARCODE
						,BUILD_OUT_FLAG
						,BUILD_OUT_QTY
						,AICO_CEPT_FLAG
						,SUPPLIER_NAME
						,PART_NAME
						,ORDER_MODE
						,KANBAN_PRINT_POINT_CD
						,KANBAN_PRINT_DATE_PLANT
						,KANBAN_PRINT_DATE_LOCAL
						,CONVEYANCE_ROUTE
						,FERRY_PORT_ARRIVAL_DT
						,FERRY_PORT_DEPART_DT
						,EKBS_FLAG
						,EKBS_DT
						,PACKAGE_TYPE
						,RECEIVE_PLANT_NAME
						,SUPPLIER_INFO1
						,SUPPLIER_INFO2
						,SUPPLIER_INFO3
						,PRINT_CD
						,IMPORTIR_INFO
						,IMPORTIR_INFO2
						,IMPORTIR_INFO3
						,IMPORTIR_INFO4
						,CREATED_BY
						,CREATED_DT
						,CHANGED_BY
						,CHANGED_DT
						,POSTING_STS
						,CASE_NO
						,MOD_DST_CD
						,BOX_NO
						,PLN_PCK_DT
						,CONT_SNO
						,PROCESS_TYPE
						,LOT_MOD_NO
						,CANCEL_FLAG
						,CANCEL_BY
						,CANCEL_DT
						,REMARK
						,GETDATE()
					FROM TB_S_DAILY_ORDER_PART
					WHERE (ORDER_QTY / QTY_PER_CONTAINER) >= @RN2
						AND ISNULL(ORDER_QTY, 0) > 0
						AND ISNULL(PART_BARCODE, '') = ''
						AND ISNULL(ORDER_PLAN_QTY_LOT, 0) > 0

					SET @RN2 = @RN2 + 1

					SELECT @T_COUNT2 = COUNT(1)
					FROM TB_S_DAILY_ORDER_PART
					WHERE ORDER_QTY >= @RN2
						AND ISNULL(ORDER_QTY, 0) > 0
						AND ISNULL(PART_BARCODE, '') = ''
						AND ISNULL(ORDER_PLAN_QTY_LOT, 0) > 0
				END

				SET @log = 'Generate and update part barcode as new Kanban 2';

				INSERT INTO @TB_T_LOG_D
				SELECT @pid
					,NULL
					,'MCEDSTD021I'
					,'INF'
					,@log
					,'Generate and update part barcode'
					,@Username
					,GETDATE()

				INSERT INTO TB_S_DAILY_ORDER_PART_KANBAN2_FILTER (
					MANIFEST_NO
					,ITEM_NO
					,SEQ_KANBAN_ITEM
					,KANBAN_ID_2
					,SUPPLIER_PLANT
					,RCV_PLANT_CD
					,DOCK_CD
					,PART_NO
					,KANBAN_PRINT_ADDRESS
					,KANBAN_NO
					,QTY_PER_CONTAINER
					,ORDER_QTY
					,ORDER_PLAN_QTY_LOT
					,RECEIVED_STATUS
					,PART_BARCODE
					,BUILD_OUT_FLAG
					,BUILD_OUT_QTY
					,AICO_CEPT_FLAG
					,SUPPLIER_NAME
					,PART_NAME
					,ORDER_MODE
					,KANBAN_PRINT_POINT_CD
					,KANBAN_PRINT_DATE_PLANT
					,KANBAN_PRINT_DATE_LOCAL
					,CONVEYANCE_ROUTE
					,FERRY_PORT_ARRIVAL_DT
					,FERRY_PORT_DEPART_DT
					,EKBS_FLAG
					,EKBS_DT
					,PACKAGE_TYPE
					,RECEIVE_PLANT_NAME
					,SUPPLIER_INFO1
					,SUPPLIER_INFO2
					,SUPPLIER_INFO3
					,PRINT_CD
					,IMPORTIR_INFO
					,IMPORTIR_INFO2
					,IMPORTIR_INFO3
					,IMPORTIR_INFO4
					,CREATED_BY
					,CREATED_DT
					,CHANGED_BY
					,CHANGED_DT
					,POSTING_STS
					,CASE_NO
					,MOD_DST_CD
					,BOX_NO
					,PLN_PCK_DT
					,CONT_SNO
					,PROCESS_TYPE
					,LOT_MOD_NO
					,CANCEL_FLAG
					,CANCEL_BY
					,CANCEL_DT
					,REMARK
					,AGENT_PROCESSED_DT
					)
				SELECT MANIFEST_NO
					,ITEM_NO
					,ROW_NUMBER() OVER (
						PARTITION BY MANIFEST_NO ORDER BY MANIFEST_NO --, ITEM_NO
							,ITEM_NO
							,PART_NO
						) SEQ_KANBAN_ITEM
					,MANIFEST_NO + RIGHT('00' + CAST(ITEM_NO AS VARCHAR(10)), 3) + RIGHT('00' + CAST(ROW_NUMBER() OVER (
								PARTITION BY MANIFEST_NO
								,ITEM_NO ORDER BY MANIFEST_NO
									,ITEM_NO
									,PART_NO
								) AS VARCHAR(10)), 3) KANBAN_ID_2
					,SUPPLIER_PLANT
					,RCV_PLANT_CD
					,DOCK_CD
					,PART_NO
					,KANBAN_PRINT_ADDRESS
					,KANBAN_NO
					,QTY_PER_CONTAINER
					,ORDER_QTY
					,ORDER_PLAN_QTY_LOT
					,RECEIVED_STATUS
					,PART_BARCODE
					,BUILD_OUT_FLAG
					,BUILD_OUT_QTY
					,AICO_CEPT_FLAG
					,SUPPLIER_NAME
					,PART_NAME
					,ORDER_MODE
					,KANBAN_PRINT_POINT_CD
					,KANBAN_PRINT_DATE_PLANT
					,KANBAN_PRINT_DATE_LOCAL
					,CONVEYANCE_ROUTE
					,FERRY_PORT_ARRIVAL_DT
					,FERRY_PORT_DEPART_DT
					,EKBS_FLAG
					,EKBS_DT
					,PACKAGE_TYPE
					,RECEIVE_PLANT_NAME
					,SUPPLIER_INFO1
					,SUPPLIER_INFO2
					,SUPPLIER_INFO3
					,PRINT_CD
					,IMPORTIR_INFO
					,IMPORTIR_INFO2
					,IMPORTIR_INFO3
					,IMPORTIR_INFO4
					,CREATED_BY
					,CREATED_DT
					,CHANGED_BY
					,CHANGED_DT
					,POSTING_STS
					,CASE_NO
					,MOD_DST_CD
					,BOX_NO
					,PLN_PCK_DT
					,CONT_SNO
					,PROCESS_TYPE
					,LOT_MOD_NO
					,CANCEL_FLAG
					,CANCEL_BY
					,CANCEL_DT
					,REMARK
					,GETDATE()
				FROM TB_S_DAILY_ORDER_PART_KANBAN2

				IF OBJECT_ID('tempdb..#TB_T_LIST_DATA_NOT_GENERATE') IS NOT NULL
					DROP TABLE #TB_T_LIST_DATA_NOT_GENERATE

				SELECT P.MANIFEST_NO
					,(
						SELECT MAX(SEQ_KANBAN_ITEM) AS MAX_ITEM_NO
						FROM TB_S_DAILY_ORDER_PART_KANBAN2_FILTER F
						WHERE F.MANIFEST_NO = P.MANIFEST_NO
						GROUP BY MANIFEST_NO
						) + ROW_NUMBER() OVER (
						PARTITION BY MANIFEST_NO ORDER BY MANIFEST_NO
							,ITEM_NO
						) ITEM_NO
					,P.SUPPLIER_PLANT
					,P.RCV_PLANT_CD
					,P.DOCK_CD
					,P.PART_NO
					,P.KANBAN_PRINT_ADDRESS
					,P.KANBAN_NO
					,P.QTY_PER_CONTAINER
					,P.ORDER_QTY
					,P.ORDER_PLAN_QTY_LOT
					,P.RECEIVED_STATUS
					,P.PART_BARCODE
					,P.BUILD_OUT_FLAG
					,P.BUILD_OUT_QTY
					,P.AICO_CEPT_FLAG
					,P.SUPPLIER_NAME
					,P.PART_NAME
					,P.ORDER_MODE
					,P.KANBAN_PRINT_POINT_CD
					,P.KANBAN_PRINT_DATE_PLANT
					,P.KANBAN_PRINT_DATE_LOCAL
					,P.CONVEYANCE_ROUTE
					,P.FERRY_PORT_ARRIVAL_DT
					,P.FERRY_PORT_DEPART_DT
					,P.EKBS_FLAG
					,P.EKBS_DT
					,P.PACKAGE_TYPE
					,P.RECEIVE_PLANT_NAME
					,P.SUPPLIER_INFO1
					,P.SUPPLIER_INFO2
					,P.SUPPLIER_INFO3
					,P.PRINT_CD
					,P.IMPORTIR_INFO
					,P.IMPORTIR_INFO2
					,P.IMPORTIR_INFO3
					,P.IMPORTIR_INFO4
					,P.CREATED_BY
					,P.CREATED_DT
					,P.CHANGED_BY
					,P.CHANGED_DT
					,P.POSTING_STS
					,P.CASE_NO
					,P.MOD_DST_CD
					,P.BOX_NO
					,P.PLN_PCK_DT
					,P.CONT_SNO
					,P.PROCESS_TYPE
					,P.LOT_MOD_NO
					,P.CANCEL_FLAG
					,P.CANCEL_BY
					,P.CANCEL_DT
					,P.REMARK
				INTO #TB_T_LIST_DATA_NOT_GENERATE
				FROM TB_S_DAILY_ORDER_PART P
				WHERE MANIFEST_NO + '' + CONVERT(VARCHAR, ITEM_NO) NOT IN (
						SELECT DISTINCT MANIFEST_NO + '' + CONVERT(VARCHAR, ITEM_NO)
						FROM TB_S_DAILY_ORDER_PART_KANBAN2_FILTER
						)
					AND MANIFEST_NO IN (
						SELECT DISTINCT MANIFEST_NO
						FROM TB_S_DAILY_ORDER_PART_KANBAN2
						)

				SET @log = 'Delete data from Daily Order Part Table';

				INSERT INTO @TB_T_LOG_D
				SELECT @pid
					,NULL
					,'MCEDSTD021I'
					,'INF'
					,@log
					,'Delete Daily Order Part data'
					,@Username
					,GETDATE()

				PRINT @log

				DELETE
				FROM TB_R_DAILY_ORDER_PART
				WHERE MANIFEST_NO IN (
						SELECT DISTINCT MANIFEST_NO
						FROM TB_S_DAILY_ORDER_PART
						WHERE 1 = 1
							AND MANIFEST_NO IN (
								SELECT DISTINCT MANIFEST_NO
								FROM TB_S_DAILY_ORDER_PART_KANBAN2
								)
						)

				SET @log = 'Insert generated Kanban 2 into Daily Order Part table';

				INSERT INTO @TB_T_LOG_D
				SELECT @pid
					,NULL
					,'MCEDSTD021I'
					,'INF'
					,@log
					,'Insert generated Kanban 2'
					,@Username
					,GETDATE()

				PRINT 'Sebelum insert'

				INSERT INTO TB_R_DAILY_ORDER_PART (
					MANIFEST_NO
					,ITEM_NO
					,SUPPLIER_PLANT
					,RCV_PLANT_CD
					,DOCK_CD
					,PART_NO
					,KANBAN_PRINT_ADDRESS
					,KANBAN_NO
					,QTY_PER_CONTAINER
					,ORDER_QTY
					,ORDER_PLAN_QTY_LOT
					,RECEIVED_STATUS
					,PART_BARCODE
					,BUILD_OUT_FLAG
					,BUILD_OUT_QTY
					,AICO_CEPT_FLAG
					,SUPPLIER_NAME
					,PART_NAME
					,ORDER_MODE
					,KANBAN_PRINT_POINT_CD
					,KANBAN_PRINT_DATE_PLANT
					,KANBAN_PRINT_DATE_LOCAL
					,CONVEYANCE_ROUTE
					,FERRY_PORT_ARRIVAL_DT
					,FERRY_PORT_DEPART_DT
					,EKBS_FLAG
					,EKBS_DT
					,PACKAGE_TYPE
					,RECEIVE_PLANT_NAME
					,SUPPLIER_INFO1
					,SUPPLIER_INFO2
					,SUPPLIER_INFO3
					,PRINT_CD
					,IMPORTIR_INFO
					,IMPORTIR_INFO2
					,IMPORTIR_INFO3
					,IMPORTIR_INFO4
					,CREATED_BY
					,CREATED_DT
					,CHANGED_BY
					,CHANGED_DT
					,POSTING_STS
					,CASE_NO
					,MOD_DST_CD
					,BOX_NO
					,PLN_PCK_DT
					,CONT_SNO
					,PROCESS_TYPE
					,LOT_MOD_NO
					)
				SELECT MANIFEST_NO
					,SEQ_KANBAN_ITEM AS ITEM_NO
					,SUPPLIER_PLANT
					,RCV_PLANT_CD
					,DOCK_CD
					,PART_NO
					,KANBAN_PRINT_ADDRESS
					,KANBAN_NO
					,QTY_PER_CONTAINER
					,ORDER_QTY
					,ORDER_PLAN_QTY_LOT
					,RECEIVED_STATUS
					,KANBAN_ID_2 PART_BARCODE
					,BUILD_OUT_FLAG
					,BUILD_OUT_QTY
					,AICO_CEPT_FLAG
					,SUPPLIER_NAME
					,PART_NAME
					,ORDER_MODE
					,KANBAN_PRINT_POINT_CD
					,KANBAN_PRINT_DATE_PLANT
					,KANBAN_PRINT_DATE_LOCAL
					,CONVEYANCE_ROUTE
					,FERRY_PORT_ARRIVAL_DT
					,FERRY_PORT_DEPART_DT
					,EKBS_FLAG
					,EKBS_DT
					,PACKAGE_TYPE
					,RECEIVE_PLANT_NAME
					,SUPPLIER_INFO1
					,SUPPLIER_INFO2
					,SUPPLIER_INFO3
					,PRINT_CD
					,IMPORTIR_INFO
					,IMPORTIR_INFO2
					,IMPORTIR_INFO3
					,IMPORTIR_INFO4
					,CREATED_BY
					,CREATED_DT
					,@Username CHANGED_BY
					,GETDATE() CHANGED_DT
					,POSTING_STS
					,CASE_NO
					,MOD_DST_CD
					,BOX_NO
					,PLN_PCK_DT
					,CONT_SNO
					,PROCESS_TYPE
					,LOT_MOD_NO
				FROM TB_S_DAILY_ORDER_PART_KANBAN2_FILTER
				
				UNION ALL
				
				SELECT MANIFEST_NO
					,ITEM_NO
					,SUPPLIER_PLANT
					,RCV_PLANT_CD
					,DOCK_CD
					,PART_NO
					,KANBAN_PRINT_ADDRESS
					,KANBAN_NO
					,QTY_PER_CONTAINER
					,ORDER_QTY
					,ORDER_PLAN_QTY_LOT
					,RECEIVED_STATUS
					,PART_BARCODE
					,BUILD_OUT_FLAG
					,BUILD_OUT_QTY
					,AICO_CEPT_FLAG
					,SUPPLIER_NAME
					,PART_NAME
					,ORDER_MODE
					,KANBAN_PRINT_POINT_CD
					,KANBAN_PRINT_DATE_PLANT
					,KANBAN_PRINT_DATE_LOCAL
					,CONVEYANCE_ROUTE
					,FERRY_PORT_ARRIVAL_DT
					,FERRY_PORT_DEPART_DT
					,EKBS_FLAG
					,EKBS_DT
					,PACKAGE_TYPE
					,RECEIVE_PLANT_NAME
					,SUPPLIER_INFO1
					,SUPPLIER_INFO2
					,SUPPLIER_INFO3
					,PRINT_CD
					,IMPORTIR_INFO
					,IMPORTIR_INFO2
					,IMPORTIR_INFO3
					,IMPORTIR_INFO4
					,CREATED_BY
					,CREATED_DT
					,@Username CHANGED_BY
					,GETDATE() CHANGED_DT
					,POSTING_STS
					,CASE_NO
					,MOD_DST_CD
					,BOX_NO
					,PLN_PCK_DT
					,CONT_SNO
					,PROCESS_TYPE
					,LOT_MOD_NO
				FROM #TB_T_LIST_DATA_NOT_GENERATE

				SET @log = 'Create Kanban 2 Batch is ended with success.';

				INSERT INTO @TB_T_LOG_D
				SELECT @pid
					,NULL
					,'MCEDSTD008I'
					,'INF'
					,@log
					,'End log with success'
					,@Username
					,GETDATE()

				SELECT TOP 1 @R_SEQ_NO = SEQUENCE_NUMBER
				FROM TB_R_LOG_D
				WHERE PROCESS_ID = @pid
				ORDER BY SEQUENCE_NUMBER DESC

				INSERT INTO TB_R_LOG_D (
					PROCESS_ID
					,SEQUENCE_NUMBER
					,MESSAGE_ID
					,MESSAGE_TYPE
					,[MESSAGE]
					,LOCATION
					,CREATED_BY
					,CREATED_DATE
					)
				SELECT PROCESS_ID
					,@R_SEQ_NO + ROW_NUMBER() OVER (
						ORDER BY PROCESS_ID
						)
					,MESSAGE_ID
					,MESSAGE_TYPE
					,[MESSAGE]
					,LOCATION
					,CREATED_BY
					,CREATED_DATE
				FROM @TB_T_LOG_D

				UPDATE TB_R_LOG_H
				SET PROCESS_STATUS = 1
				WHERE PROCESS_ID = @pid
			END
					--SELECT * FROM TB_S_DAILY_ORDER_PART_KANBAN2_FILTER
					SELECT * FROM TB_R_LOG_D WHERE PROCESS_ID =  @pid
		END
END

